﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim Sql1 As SQL
	Public SelectedDBFullPath As String = File.DirApp & "/db/MyDB.db"
	Public Query As String
	Public StartTime,EndTime As Long
	
End Sub


Sub InitSQlite
	'Create db folder under objects
	If File.Exists(File.DirApp & "/db","") = False Then 
		File.MakeDir(File.DirApp, "db")
	End If
	
	'DB will be created automatically if it doesn't exist
	Sql1.InitializeSQLite("", SelectedDBFullPath , True)
	
	'create the tables we need
	CreateTables
	InsertCustomersAndOrders
		
	
	
	
End Sub

Sub CloseDB
	Sql1.Close
End Sub

Sub GetCustomers As List
	Dim ReturnList As List
	ReturnList.Initialize
	
	StartTime=DateTime.now
	
	Dim RS As ResultSet=Sql1.ExecQuery("SELECT * FROM customers LIMIT 100")
	Do While RS.NextRow
		Dim m As Map
		m.Initialize
		For i=0 To RS.ColumnCount-1
			m.Put(RS.GetColumnName(i),RS.GetString2(i))
		Next
		ReturnList.Add(m)
	Loop
	RS.Close
	EndTime=DateTime.now
	Log(StartTime)
	Log(EndTime)
	CallSubDelayed2(Main,"LastQueryDuration",EndTime-StartTime)
	
	Return ReturnList
End Sub

Sub ShowCustomer (CustomerID As Int) As List
	Dim ReturnList As List
	ReturnList.Initialize
	StartTime=DateTime.now
	Dim RS As ResultSet=Sql1.ExecQuery2("SELECT * FROM customers WHERE cid=?",Array As String(CustomerID))
	
	Do While RS.NextRow
		Dim m As Map
		m.Initialize
		For i=0 To RS.ColumnCount-1
			m.Put(RS.GetColumnName(i),RS.GetString2(i))
		Next
		ReturnList.Add(m)
	Loop
	RS.Close
	
	EndTime=DateTime.now
	Log(StartTime)
	Log(EndTime)
	
	CallSubDelayed2(Main,"LastQueryDuration",EndTime-StartTime)
	Return ReturnList
End Sub

Sub GetOrdersFromCustomer (CustomerID As Int) As List
	Dim ReturnList As List
	ReturnList.Initialize
	StartTime=DateTime.now
	Dim RS As ResultSet=Sql1.ExecQuery2("SELECT * FROM orders WHERE cid=?",Array As String(CustomerID))
		
	Do While RS.NextRow
		Dim m As Map
		m.Initialize
		For i=0 To RS.ColumnCount-1
			m.Put(RS.GetColumnName(i),RS.GetString2(i))
		Next
		ReturnList.Add(m)
	Loop
	RS.Close
	
	EndTime=DateTime.now
	Log(StartTime)
	Log(EndTime)
	CallSubDelayed2(Main,"LastQueryDuration",EndTime-StartTime)
	Return ReturnList
End Sub



Sub CreateTables
	
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS 'customers' ( `cid` INTEGER PRIMARY KEY AUTOINCREMENT, `cname` TEXT)")
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS 'orders' ( `oid` INTEGER PRIMARY KEY AUTOINCREMENT, `cid` INTEGER, `otime` TEXT, `ostatus` TEXT, `itemcount` INTEGER, `ordertotalprice` REAL, `taxtotal` REAL) ")
	Sql1.ExecNonQuery("CREATE INDEX IF NOT EXISTS `CID` ON `orders` ( `cid` Asc )")
End Sub

Sub InsertCustomersAndOrders
	
	Dim RowsCount As Int
	RowsCount=Sql1.ExecQuerySingleResult("SELECT COUNT (*) From Customers")
	If RowsCount>=1000000 Then
		CallSubDelayed(Main,"AlreadyInserted")
		Return
	End If
	
	Dim LastIndertedCustomerID As Int, CustomerName As String
	Dim ItemCount As Int, ItemPrice As Float, Tax As Float
	
	Sql1.BeginTransaction
	For i = 1 To 1000000
		Sleep(0)	
		If i Mod 1000=0 Then
			Log(i)
			CallSubDelayed2(Main,"ShowInsertedCustomers",i)
			Sql1.TransactionSuccessful
			Sql1.BeginTransaction
		End If
		
		
		CustomerName="Customer " & i
		Sql1.ExecNonQuery2("INSERT INTO customers VALUES (?,?)", Array(Null, CustomerName))
		LastIndertedCustomerID=Sql1.ExecQuerySingleResult("SELECT last_insert_rowid()")
			
		'Insert 5 Orders	
		For o=1 To 5
			ItemPrice=Rnd(1000,10000)/100
			ItemCount=Rnd(1,21)
			Tax=ItemPrice*11.5/100
			Sql1.ExecNonQuery2("INSERT INTO orders VALUES (?,?,?,?,?,?,?)", Array(Null,LastIndertedCustomerID,DateTime.Now,"N",ItemCount,NumberFormat2(ItemPrice,1,2,2,False),NumberFormat2(Tax,1,2,2,False) ))
		Next
	Next
	Sql1.TransactionSuccessful
	
	Query= "PRAGMA foreign_keys = ON" 'foreign keys=on
	Sql1.ExecNONQuery(Query)
	Query = "PRAGMA journal_mode = wal" 'multiple access at one time
	Sql1.ExecNONQuery(Query)
End Sub




